// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: controller.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Ctrlmsg {

  /// <summary>Holder for reflection information generated from controller.proto</summary>
  public static partial class ControllerReflection {

    #region Descriptor
    /// <summary>File descriptor for controller.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static ControllerReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "ChBjb250cm9sbGVyLnByb3RvEgdjdHJsbXNnGgphdXRoLnByb3RvGg1tb25z",
            "dGVyLnByb3RvGgp1c2VyLnByb3RvGg9pbnZlbnRvcnkucHJvdG8aEmludGVy",
            "YWN0aW9ucy5wcm90bxoLcXVlc3QucHJvdG8aDGJhdHRsZS5wcm90byK2AQoF",
            "RXZlbnQSKQoIbW9uRXZlbnQYASABKAsyFS5tb25zdGVyLk1vbnN0ZXJFdmVu",
            "dEgAEiQKCWl0ZW1FdmVudBgCIAEoCzIPLml0ZW0uSXRlbUV2ZW50SAASJwoK",
            "cXVlc3RFdmVudBgDIAEoCzIRLnF1ZXN0LlF1ZXN0RXZlbnRIABIqCgtiYXR0",
            "bGVFdmVudBgEIAEoCzITLmJhdHRsZS5CYXR0bGVFdmVudEgAQgcKBWV2ZW50",
            "IucCCghGdW5jQ2FsbBIyChFhdXRoX3NlcnZpY2VfY2FsbBgBIAEoCzIVLmF1",
            "dGguQXV0aFNlcnZpY2VDYWxsSAASMwoQbW9uX3NlcnZpY2VfY2FsbBgCIAEo",
            "CzIXLm1vbnN0ZXIuTW9uU2VydmljZUNhbGxIABIyChF1c2VyX3NlcnZpY2Vf",
            "Y2FsbBgDIAEoCzIVLnVzZXIuVXNlclNlcnZpY2VDYWxsSAASNgoQaW52X3Nl",
            "cnZpY2VfY2FsbBgEIAEoCzIaLml0ZW0uSW52ZW50b3J5U2VydmljZUNhbGxI",
            "ABJEChVpbnRlcmFjdF9zZXJ2aWNlX2NhbGwYBSABKAsyIy5pbnRlcmFjdGlv",
            "bi5JbnRlcmFjdGlvblNlcnZpY2VDYWxsSAASNQoScXVlc3Rfc2VydmljZV9j",
            "YWxsGAYgASgLMhcucXVlc3QuUXVlc3RTZXJ2aWNlQ2FsbEgAQgkKB21lc3Nh",
            "Z2UifwoHTWVzc2FnZRIhCgRjYWxsGAEgASgLMhEuY3RybG1zZy5GdW5jQ2Fs",
            "bEgAEikKCHJlc3BvbnNlGAIgASgLMhUuY3RybG1zZy5GdW5jUmVzcG9uc2VI",
            "ABIfCgVldmVudBgDIAEoCzIOLmN0cmxtc2cuRXZlbnRIAEIFCgNtc2ci/QIK",
            "DEZ1bmNSZXNwb25zZRI2Cg9tb25fc2VydmljZV9yZXMYASABKAsyGy5tb25z",
            "dGVyLk1vblNlcnZpY2VSZXNwb25zZUgAEjUKEGF1dGhfc2VydmljZV9yZXMY",
            "AiABKAsyGS5hdXRoLkF1dGhTZXJ2aWNlUmVzcG9uc2VIABI1ChB1c2VyX3Nl",
            "cnZpY2VfcmVzGAMgASgLMhkudXNlci5Vc2VyU2VydmljZVJlc3BvbnNlSAAS",
            "OQoPaW52X3NlcnZpY2VfcmVzGAQgASgLMh4uaXRlbS5JbnZlbnRvcnlTZXJ2",
            "aWNlUmVzcG9uc2VIABJHChRpbnRlcmFjdF9zZXJ2aWNlX3JlcxgFIAEoCzIn",
            "LmludGVyYWN0aW9uLkludGVyYWN0aW9uU2VydmljZVJlc3BvbnNlSAASOAoR",
            "cXVlc3Rfc2VydmljZV9yZXMYBiABKAsyGy5xdWVzdC5RdWVzdFNlcnZpY2VS",
            "ZXNwb25zZUgAQgkKB21lc3NhZ2VCMFouZ2l0bGFiLmNvbS92YWphcl9taW5p",
            "Z2FtZS9wcm90b19nby9nZW4vY3RybG1zZ2IGcHJvdG8z"));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Auth.AuthReflection.Descriptor, global::Monster.MonsterReflection.Descriptor, global::User.UserReflection.Descriptor, global::Item.InventoryReflection.Descriptor, global::Interaction.InteractionsReflection.Descriptor, global::Quest.QuestReflection.Descriptor, global::Battle.BattleReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Ctrlmsg.Event), global::Ctrlmsg.Event.Parser, new[]{ "MonEvent", "ItemEvent", "QuestEvent", "BattleEvent" }, new[]{ "Event" }, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Ctrlmsg.FuncCall), global::Ctrlmsg.FuncCall.Parser, new[]{ "AuthServiceCall", "MonServiceCall", "UserServiceCall", "InvServiceCall", "InteractServiceCall", "QuestServiceCall" }, new[]{ "Message" }, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Ctrlmsg.Message), global::Ctrlmsg.Message.Parser, new[]{ "Call", "Response", "Event" }, new[]{ "Msg" }, null, null, null),
            new pbr::GeneratedClrTypeInfo(typeof(global::Ctrlmsg.FuncResponse), global::Ctrlmsg.FuncResponse.Parser, new[]{ "MonServiceRes", "AuthServiceRes", "UserServiceRes", "InvServiceRes", "InteractServiceRes", "QuestServiceRes" }, new[]{ "Message" }, null, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Event : pb::IMessage<Event>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Event> _parser = new pb::MessageParser<Event>(() => new Event());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<Event> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Ctrlmsg.ControllerReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Event() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Event(Event other) : this() {
      switch (other.EventCase) {
        case EventOneofCase.MonEvent:
          MonEvent = other.MonEvent.Clone();
          break;
        case EventOneofCase.ItemEvent:
          ItemEvent = other.ItemEvent.Clone();
          break;
        case EventOneofCase.QuestEvent:
          QuestEvent = other.QuestEvent.Clone();
          break;
        case EventOneofCase.BattleEvent:
          BattleEvent = other.BattleEvent.Clone();
          break;
      }

      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Event Clone() {
      return new Event(this);
    }

    /// <summary>Field number for the "monEvent" field.</summary>
    public const int MonEventFieldNumber = 1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Monster.MonsterEvent MonEvent {
      get { return eventCase_ == EventOneofCase.MonEvent ? (global::Monster.MonsterEvent) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.MonEvent;
      }
    }

    /// <summary>Field number for the "itemEvent" field.</summary>
    public const int ItemEventFieldNumber = 2;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Item.ItemEvent ItemEvent {
      get { return eventCase_ == EventOneofCase.ItemEvent ? (global::Item.ItemEvent) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.ItemEvent;
      }
    }

    /// <summary>Field number for the "questEvent" field.</summary>
    public const int QuestEventFieldNumber = 3;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Quest.QuestEvent QuestEvent {
      get { return eventCase_ == EventOneofCase.QuestEvent ? (global::Quest.QuestEvent) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.QuestEvent;
      }
    }

    /// <summary>Field number for the "battleEvent" field.</summary>
    public const int BattleEventFieldNumber = 4;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Battle.BattleEvent BattleEvent {
      get { return eventCase_ == EventOneofCase.BattleEvent ? (global::Battle.BattleEvent) event_ : null; }
      set {
        event_ = value;
        eventCase_ = value == null ? EventOneofCase.None : EventOneofCase.BattleEvent;
      }
    }

    private object event_;
    /// <summary>Enum of possible cases for the "event" oneof.</summary>
    public enum EventOneofCase {
      None = 0,
      MonEvent = 1,
      ItemEvent = 2,
      QuestEvent = 3,
      BattleEvent = 4,
    }
    private EventOneofCase eventCase_ = EventOneofCase.None;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public EventOneofCase EventCase {
      get { return eventCase_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void ClearEvent() {
      eventCase_ = EventOneofCase.None;
      event_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as Event);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(Event other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(MonEvent, other.MonEvent)) return false;
      if (!object.Equals(ItemEvent, other.ItemEvent)) return false;
      if (!object.Equals(QuestEvent, other.QuestEvent)) return false;
      if (!object.Equals(BattleEvent, other.BattleEvent)) return false;
      if (EventCase != other.EventCase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (eventCase_ == EventOneofCase.MonEvent) hash ^= MonEvent.GetHashCode();
      if (eventCase_ == EventOneofCase.ItemEvent) hash ^= ItemEvent.GetHashCode();
      if (eventCase_ == EventOneofCase.QuestEvent) hash ^= QuestEvent.GetHashCode();
      if (eventCase_ == EventOneofCase.BattleEvent) hash ^= BattleEvent.GetHashCode();
      hash ^= (int) eventCase_;
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (eventCase_ == EventOneofCase.MonEvent) {
        output.WriteRawTag(10);
        output.WriteMessage(MonEvent);
      }
      if (eventCase_ == EventOneofCase.ItemEvent) {
        output.WriteRawTag(18);
        output.WriteMessage(ItemEvent);
      }
      if (eventCase_ == EventOneofCase.QuestEvent) {
        output.WriteRawTag(26);
        output.WriteMessage(QuestEvent);
      }
      if (eventCase_ == EventOneofCase.BattleEvent) {
        output.WriteRawTag(34);
        output.WriteMessage(BattleEvent);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (eventCase_ == EventOneofCase.MonEvent) {
        output.WriteRawTag(10);
        output.WriteMessage(MonEvent);
      }
      if (eventCase_ == EventOneofCase.ItemEvent) {
        output.WriteRawTag(18);
        output.WriteMessage(ItemEvent);
      }
      if (eventCase_ == EventOneofCase.QuestEvent) {
        output.WriteRawTag(26);
        output.WriteMessage(QuestEvent);
      }
      if (eventCase_ == EventOneofCase.BattleEvent) {
        output.WriteRawTag(34);
        output.WriteMessage(BattleEvent);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (eventCase_ == EventOneofCase.MonEvent) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(MonEvent);
      }
      if (eventCase_ == EventOneofCase.ItemEvent) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(ItemEvent);
      }
      if (eventCase_ == EventOneofCase.QuestEvent) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(QuestEvent);
      }
      if (eventCase_ == EventOneofCase.BattleEvent) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(BattleEvent);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(Event other) {
      if (other == null) {
        return;
      }
      switch (other.EventCase) {
        case EventOneofCase.MonEvent:
          if (MonEvent == null) {
            MonEvent = new global::Monster.MonsterEvent();
          }
          MonEvent.MergeFrom(other.MonEvent);
          break;
        case EventOneofCase.ItemEvent:
          if (ItemEvent == null) {
            ItemEvent = new global::Item.ItemEvent();
          }
          ItemEvent.MergeFrom(other.ItemEvent);
          break;
        case EventOneofCase.QuestEvent:
          if (QuestEvent == null) {
            QuestEvent = new global::Quest.QuestEvent();
          }
          QuestEvent.MergeFrom(other.QuestEvent);
          break;
        case EventOneofCase.BattleEvent:
          if (BattleEvent == null) {
            BattleEvent = new global::Battle.BattleEvent();
          }
          BattleEvent.MergeFrom(other.BattleEvent);
          break;
      }

      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            global::Monster.MonsterEvent subBuilder = new global::Monster.MonsterEvent();
            if (eventCase_ == EventOneofCase.MonEvent) {
              subBuilder.MergeFrom(MonEvent);
            }
            input.ReadMessage(subBuilder);
            MonEvent = subBuilder;
            break;
          }
          case 18: {
            global::Item.ItemEvent subBuilder = new global::Item.ItemEvent();
            if (eventCase_ == EventOneofCase.ItemEvent) {
              subBuilder.MergeFrom(ItemEvent);
            }
            input.ReadMessage(subBuilder);
            ItemEvent = subBuilder;
            break;
          }
          case 26: {
            global::Quest.QuestEvent subBuilder = new global::Quest.QuestEvent();
            if (eventCase_ == EventOneofCase.QuestEvent) {
              subBuilder.MergeFrom(QuestEvent);
            }
            input.ReadMessage(subBuilder);
            QuestEvent = subBuilder;
            break;
          }
          case 34: {
            global::Battle.BattleEvent subBuilder = new global::Battle.BattleEvent();
            if (eventCase_ == EventOneofCase.BattleEvent) {
              subBuilder.MergeFrom(BattleEvent);
            }
            input.ReadMessage(subBuilder);
            BattleEvent = subBuilder;
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            global::Monster.MonsterEvent subBuilder = new global::Monster.MonsterEvent();
            if (eventCase_ == EventOneofCase.MonEvent) {
              subBuilder.MergeFrom(MonEvent);
            }
            input.ReadMessage(subBuilder);
            MonEvent = subBuilder;
            break;
          }
          case 18: {
            global::Item.ItemEvent subBuilder = new global::Item.ItemEvent();
            if (eventCase_ == EventOneofCase.ItemEvent) {
              subBuilder.MergeFrom(ItemEvent);
            }
            input.ReadMessage(subBuilder);
            ItemEvent = subBuilder;
            break;
          }
          case 26: {
            global::Quest.QuestEvent subBuilder = new global::Quest.QuestEvent();
            if (eventCase_ == EventOneofCase.QuestEvent) {
              subBuilder.MergeFrom(QuestEvent);
            }
            input.ReadMessage(subBuilder);
            QuestEvent = subBuilder;
            break;
          }
          case 34: {
            global::Battle.BattleEvent subBuilder = new global::Battle.BattleEvent();
            if (eventCase_ == EventOneofCase.BattleEvent) {
              subBuilder.MergeFrom(BattleEvent);
            }
            input.ReadMessage(subBuilder);
            BattleEvent = subBuilder;
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class FuncCall : pb::IMessage<FuncCall>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<FuncCall> _parser = new pb::MessageParser<FuncCall>(() => new FuncCall());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<FuncCall> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Ctrlmsg.ControllerReflection.Descriptor.MessageTypes[1]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public FuncCall() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public FuncCall(FuncCall other) : this() {
      switch (other.MessageCase) {
        case MessageOneofCase.AuthServiceCall:
          AuthServiceCall = other.AuthServiceCall.Clone();
          break;
        case MessageOneofCase.MonServiceCall:
          MonServiceCall = other.MonServiceCall.Clone();
          break;
        case MessageOneofCase.UserServiceCall:
          UserServiceCall = other.UserServiceCall.Clone();
          break;
        case MessageOneofCase.InvServiceCall:
          InvServiceCall = other.InvServiceCall.Clone();
          break;
        case MessageOneofCase.InteractServiceCall:
          InteractServiceCall = other.InteractServiceCall.Clone();
          break;
        case MessageOneofCase.QuestServiceCall:
          QuestServiceCall = other.QuestServiceCall.Clone();
          break;
      }

      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public FuncCall Clone() {
      return new FuncCall(this);
    }

    /// <summary>Field number for the "auth_service_call" field.</summary>
    public const int AuthServiceCallFieldNumber = 1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Auth.AuthServiceCall AuthServiceCall {
      get { return messageCase_ == MessageOneofCase.AuthServiceCall ? (global::Auth.AuthServiceCall) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.AuthServiceCall;
      }
    }

    /// <summary>Field number for the "mon_service_call" field.</summary>
    public const int MonServiceCallFieldNumber = 2;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Monster.MonServiceCall MonServiceCall {
      get { return messageCase_ == MessageOneofCase.MonServiceCall ? (global::Monster.MonServiceCall) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.MonServiceCall;
      }
    }

    /// <summary>Field number for the "user_service_call" field.</summary>
    public const int UserServiceCallFieldNumber = 3;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::User.UserServiceCall UserServiceCall {
      get { return messageCase_ == MessageOneofCase.UserServiceCall ? (global::User.UserServiceCall) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.UserServiceCall;
      }
    }

    /// <summary>Field number for the "inv_service_call" field.</summary>
    public const int InvServiceCallFieldNumber = 4;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Item.InventoryServiceCall InvServiceCall {
      get { return messageCase_ == MessageOneofCase.InvServiceCall ? (global::Item.InventoryServiceCall) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.InvServiceCall;
      }
    }

    /// <summary>Field number for the "interact_service_call" field.</summary>
    public const int InteractServiceCallFieldNumber = 5;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Interaction.InteractionServiceCall InteractServiceCall {
      get { return messageCase_ == MessageOneofCase.InteractServiceCall ? (global::Interaction.InteractionServiceCall) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.InteractServiceCall;
      }
    }

    /// <summary>Field number for the "quest_service_call" field.</summary>
    public const int QuestServiceCallFieldNumber = 6;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Quest.QuestServiceCall QuestServiceCall {
      get { return messageCase_ == MessageOneofCase.QuestServiceCall ? (global::Quest.QuestServiceCall) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.QuestServiceCall;
      }
    }

    private object message_;
    /// <summary>Enum of possible cases for the "message" oneof.</summary>
    public enum MessageOneofCase {
      None = 0,
      AuthServiceCall = 1,
      MonServiceCall = 2,
      UserServiceCall = 3,
      InvServiceCall = 4,
      InteractServiceCall = 5,
      QuestServiceCall = 6,
    }
    private MessageOneofCase messageCase_ = MessageOneofCase.None;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public MessageOneofCase MessageCase {
      get { return messageCase_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void ClearMessage() {
      messageCase_ = MessageOneofCase.None;
      message_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as FuncCall);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(FuncCall other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(AuthServiceCall, other.AuthServiceCall)) return false;
      if (!object.Equals(MonServiceCall, other.MonServiceCall)) return false;
      if (!object.Equals(UserServiceCall, other.UserServiceCall)) return false;
      if (!object.Equals(InvServiceCall, other.InvServiceCall)) return false;
      if (!object.Equals(InteractServiceCall, other.InteractServiceCall)) return false;
      if (!object.Equals(QuestServiceCall, other.QuestServiceCall)) return false;
      if (MessageCase != other.MessageCase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (messageCase_ == MessageOneofCase.AuthServiceCall) hash ^= AuthServiceCall.GetHashCode();
      if (messageCase_ == MessageOneofCase.MonServiceCall) hash ^= MonServiceCall.GetHashCode();
      if (messageCase_ == MessageOneofCase.UserServiceCall) hash ^= UserServiceCall.GetHashCode();
      if (messageCase_ == MessageOneofCase.InvServiceCall) hash ^= InvServiceCall.GetHashCode();
      if (messageCase_ == MessageOneofCase.InteractServiceCall) hash ^= InteractServiceCall.GetHashCode();
      if (messageCase_ == MessageOneofCase.QuestServiceCall) hash ^= QuestServiceCall.GetHashCode();
      hash ^= (int) messageCase_;
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (messageCase_ == MessageOneofCase.AuthServiceCall) {
        output.WriteRawTag(10);
        output.WriteMessage(AuthServiceCall);
      }
      if (messageCase_ == MessageOneofCase.MonServiceCall) {
        output.WriteRawTag(18);
        output.WriteMessage(MonServiceCall);
      }
      if (messageCase_ == MessageOneofCase.UserServiceCall) {
        output.WriteRawTag(26);
        output.WriteMessage(UserServiceCall);
      }
      if (messageCase_ == MessageOneofCase.InvServiceCall) {
        output.WriteRawTag(34);
        output.WriteMessage(InvServiceCall);
      }
      if (messageCase_ == MessageOneofCase.InteractServiceCall) {
        output.WriteRawTag(42);
        output.WriteMessage(InteractServiceCall);
      }
      if (messageCase_ == MessageOneofCase.QuestServiceCall) {
        output.WriteRawTag(50);
        output.WriteMessage(QuestServiceCall);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (messageCase_ == MessageOneofCase.AuthServiceCall) {
        output.WriteRawTag(10);
        output.WriteMessage(AuthServiceCall);
      }
      if (messageCase_ == MessageOneofCase.MonServiceCall) {
        output.WriteRawTag(18);
        output.WriteMessage(MonServiceCall);
      }
      if (messageCase_ == MessageOneofCase.UserServiceCall) {
        output.WriteRawTag(26);
        output.WriteMessage(UserServiceCall);
      }
      if (messageCase_ == MessageOneofCase.InvServiceCall) {
        output.WriteRawTag(34);
        output.WriteMessage(InvServiceCall);
      }
      if (messageCase_ == MessageOneofCase.InteractServiceCall) {
        output.WriteRawTag(42);
        output.WriteMessage(InteractServiceCall);
      }
      if (messageCase_ == MessageOneofCase.QuestServiceCall) {
        output.WriteRawTag(50);
        output.WriteMessage(QuestServiceCall);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (messageCase_ == MessageOneofCase.AuthServiceCall) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(AuthServiceCall);
      }
      if (messageCase_ == MessageOneofCase.MonServiceCall) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(MonServiceCall);
      }
      if (messageCase_ == MessageOneofCase.UserServiceCall) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(UserServiceCall);
      }
      if (messageCase_ == MessageOneofCase.InvServiceCall) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(InvServiceCall);
      }
      if (messageCase_ == MessageOneofCase.InteractServiceCall) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(InteractServiceCall);
      }
      if (messageCase_ == MessageOneofCase.QuestServiceCall) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(QuestServiceCall);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(FuncCall other) {
      if (other == null) {
        return;
      }
      switch (other.MessageCase) {
        case MessageOneofCase.AuthServiceCall:
          if (AuthServiceCall == null) {
            AuthServiceCall = new global::Auth.AuthServiceCall();
          }
          AuthServiceCall.MergeFrom(other.AuthServiceCall);
          break;
        case MessageOneofCase.MonServiceCall:
          if (MonServiceCall == null) {
            MonServiceCall = new global::Monster.MonServiceCall();
          }
          MonServiceCall.MergeFrom(other.MonServiceCall);
          break;
        case MessageOneofCase.UserServiceCall:
          if (UserServiceCall == null) {
            UserServiceCall = new global::User.UserServiceCall();
          }
          UserServiceCall.MergeFrom(other.UserServiceCall);
          break;
        case MessageOneofCase.InvServiceCall:
          if (InvServiceCall == null) {
            InvServiceCall = new global::Item.InventoryServiceCall();
          }
          InvServiceCall.MergeFrom(other.InvServiceCall);
          break;
        case MessageOneofCase.InteractServiceCall:
          if (InteractServiceCall == null) {
            InteractServiceCall = new global::Interaction.InteractionServiceCall();
          }
          InteractServiceCall.MergeFrom(other.InteractServiceCall);
          break;
        case MessageOneofCase.QuestServiceCall:
          if (QuestServiceCall == null) {
            QuestServiceCall = new global::Quest.QuestServiceCall();
          }
          QuestServiceCall.MergeFrom(other.QuestServiceCall);
          break;
      }

      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            global::Auth.AuthServiceCall subBuilder = new global::Auth.AuthServiceCall();
            if (messageCase_ == MessageOneofCase.AuthServiceCall) {
              subBuilder.MergeFrom(AuthServiceCall);
            }
            input.ReadMessage(subBuilder);
            AuthServiceCall = subBuilder;
            break;
          }
          case 18: {
            global::Monster.MonServiceCall subBuilder = new global::Monster.MonServiceCall();
            if (messageCase_ == MessageOneofCase.MonServiceCall) {
              subBuilder.MergeFrom(MonServiceCall);
            }
            input.ReadMessage(subBuilder);
            MonServiceCall = subBuilder;
            break;
          }
          case 26: {
            global::User.UserServiceCall subBuilder = new global::User.UserServiceCall();
            if (messageCase_ == MessageOneofCase.UserServiceCall) {
              subBuilder.MergeFrom(UserServiceCall);
            }
            input.ReadMessage(subBuilder);
            UserServiceCall = subBuilder;
            break;
          }
          case 34: {
            global::Item.InventoryServiceCall subBuilder = new global::Item.InventoryServiceCall();
            if (messageCase_ == MessageOneofCase.InvServiceCall) {
              subBuilder.MergeFrom(InvServiceCall);
            }
            input.ReadMessage(subBuilder);
            InvServiceCall = subBuilder;
            break;
          }
          case 42: {
            global::Interaction.InteractionServiceCall subBuilder = new global::Interaction.InteractionServiceCall();
            if (messageCase_ == MessageOneofCase.InteractServiceCall) {
              subBuilder.MergeFrom(InteractServiceCall);
            }
            input.ReadMessage(subBuilder);
            InteractServiceCall = subBuilder;
            break;
          }
          case 50: {
            global::Quest.QuestServiceCall subBuilder = new global::Quest.QuestServiceCall();
            if (messageCase_ == MessageOneofCase.QuestServiceCall) {
              subBuilder.MergeFrom(QuestServiceCall);
            }
            input.ReadMessage(subBuilder);
            QuestServiceCall = subBuilder;
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            global::Auth.AuthServiceCall subBuilder = new global::Auth.AuthServiceCall();
            if (messageCase_ == MessageOneofCase.AuthServiceCall) {
              subBuilder.MergeFrom(AuthServiceCall);
            }
            input.ReadMessage(subBuilder);
            AuthServiceCall = subBuilder;
            break;
          }
          case 18: {
            global::Monster.MonServiceCall subBuilder = new global::Monster.MonServiceCall();
            if (messageCase_ == MessageOneofCase.MonServiceCall) {
              subBuilder.MergeFrom(MonServiceCall);
            }
            input.ReadMessage(subBuilder);
            MonServiceCall = subBuilder;
            break;
          }
          case 26: {
            global::User.UserServiceCall subBuilder = new global::User.UserServiceCall();
            if (messageCase_ == MessageOneofCase.UserServiceCall) {
              subBuilder.MergeFrom(UserServiceCall);
            }
            input.ReadMessage(subBuilder);
            UserServiceCall = subBuilder;
            break;
          }
          case 34: {
            global::Item.InventoryServiceCall subBuilder = new global::Item.InventoryServiceCall();
            if (messageCase_ == MessageOneofCase.InvServiceCall) {
              subBuilder.MergeFrom(InvServiceCall);
            }
            input.ReadMessage(subBuilder);
            InvServiceCall = subBuilder;
            break;
          }
          case 42: {
            global::Interaction.InteractionServiceCall subBuilder = new global::Interaction.InteractionServiceCall();
            if (messageCase_ == MessageOneofCase.InteractServiceCall) {
              subBuilder.MergeFrom(InteractServiceCall);
            }
            input.ReadMessage(subBuilder);
            InteractServiceCall = subBuilder;
            break;
          }
          case 50: {
            global::Quest.QuestServiceCall subBuilder = new global::Quest.QuestServiceCall();
            if (messageCase_ == MessageOneofCase.QuestServiceCall) {
              subBuilder.MergeFrom(QuestServiceCall);
            }
            input.ReadMessage(subBuilder);
            QuestServiceCall = subBuilder;
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class Message : pb::IMessage<Message>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Message> _parser = new pb::MessageParser<Message>(() => new Message());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<Message> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Ctrlmsg.ControllerReflection.Descriptor.MessageTypes[2]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Message() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Message(Message other) : this() {
      switch (other.MsgCase) {
        case MsgOneofCase.Call:
          Call = other.Call.Clone();
          break;
        case MsgOneofCase.Response:
          Response = other.Response.Clone();
          break;
        case MsgOneofCase.Event:
          Event = other.Event.Clone();
          break;
      }

      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public Message Clone() {
      return new Message(this);
    }

    /// <summary>Field number for the "call" field.</summary>
    public const int CallFieldNumber = 1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Ctrlmsg.FuncCall Call {
      get { return msgCase_ == MsgOneofCase.Call ? (global::Ctrlmsg.FuncCall) msg_ : null; }
      set {
        msg_ = value;
        msgCase_ = value == null ? MsgOneofCase.None : MsgOneofCase.Call;
      }
    }

    /// <summary>Field number for the "response" field.</summary>
    public const int ResponseFieldNumber = 2;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Ctrlmsg.FuncResponse Response {
      get { return msgCase_ == MsgOneofCase.Response ? (global::Ctrlmsg.FuncResponse) msg_ : null; }
      set {
        msg_ = value;
        msgCase_ = value == null ? MsgOneofCase.None : MsgOneofCase.Response;
      }
    }

    /// <summary>Field number for the "event" field.</summary>
    public const int EventFieldNumber = 3;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Ctrlmsg.Event Event {
      get { return msgCase_ == MsgOneofCase.Event ? (global::Ctrlmsg.Event) msg_ : null; }
      set {
        msg_ = value;
        msgCase_ = value == null ? MsgOneofCase.None : MsgOneofCase.Event;
      }
    }

    private object msg_;
    /// <summary>Enum of possible cases for the "msg" oneof.</summary>
    public enum MsgOneofCase {
      None = 0,
      Call = 1,
      Response = 2,
      Event = 3,
    }
    private MsgOneofCase msgCase_ = MsgOneofCase.None;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public MsgOneofCase MsgCase {
      get { return msgCase_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void ClearMsg() {
      msgCase_ = MsgOneofCase.None;
      msg_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as Message);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(Message other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(Call, other.Call)) return false;
      if (!object.Equals(Response, other.Response)) return false;
      if (!object.Equals(Event, other.Event)) return false;
      if (MsgCase != other.MsgCase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (msgCase_ == MsgOneofCase.Call) hash ^= Call.GetHashCode();
      if (msgCase_ == MsgOneofCase.Response) hash ^= Response.GetHashCode();
      if (msgCase_ == MsgOneofCase.Event) hash ^= Event.GetHashCode();
      hash ^= (int) msgCase_;
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (msgCase_ == MsgOneofCase.Call) {
        output.WriteRawTag(10);
        output.WriteMessage(Call);
      }
      if (msgCase_ == MsgOneofCase.Response) {
        output.WriteRawTag(18);
        output.WriteMessage(Response);
      }
      if (msgCase_ == MsgOneofCase.Event) {
        output.WriteRawTag(26);
        output.WriteMessage(Event);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (msgCase_ == MsgOneofCase.Call) {
        output.WriteRawTag(10);
        output.WriteMessage(Call);
      }
      if (msgCase_ == MsgOneofCase.Response) {
        output.WriteRawTag(18);
        output.WriteMessage(Response);
      }
      if (msgCase_ == MsgOneofCase.Event) {
        output.WriteRawTag(26);
        output.WriteMessage(Event);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (msgCase_ == MsgOneofCase.Call) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Call);
      }
      if (msgCase_ == MsgOneofCase.Response) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Response);
      }
      if (msgCase_ == MsgOneofCase.Event) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(Event);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(Message other) {
      if (other == null) {
        return;
      }
      switch (other.MsgCase) {
        case MsgOneofCase.Call:
          if (Call == null) {
            Call = new global::Ctrlmsg.FuncCall();
          }
          Call.MergeFrom(other.Call);
          break;
        case MsgOneofCase.Response:
          if (Response == null) {
            Response = new global::Ctrlmsg.FuncResponse();
          }
          Response.MergeFrom(other.Response);
          break;
        case MsgOneofCase.Event:
          if (Event == null) {
            Event = new global::Ctrlmsg.Event();
          }
          Event.MergeFrom(other.Event);
          break;
      }

      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            global::Ctrlmsg.FuncCall subBuilder = new global::Ctrlmsg.FuncCall();
            if (msgCase_ == MsgOneofCase.Call) {
              subBuilder.MergeFrom(Call);
            }
            input.ReadMessage(subBuilder);
            Call = subBuilder;
            break;
          }
          case 18: {
            global::Ctrlmsg.FuncResponse subBuilder = new global::Ctrlmsg.FuncResponse();
            if (msgCase_ == MsgOneofCase.Response) {
              subBuilder.MergeFrom(Response);
            }
            input.ReadMessage(subBuilder);
            Response = subBuilder;
            break;
          }
          case 26: {
            global::Ctrlmsg.Event subBuilder = new global::Ctrlmsg.Event();
            if (msgCase_ == MsgOneofCase.Event) {
              subBuilder.MergeFrom(Event);
            }
            input.ReadMessage(subBuilder);
            Event = subBuilder;
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            global::Ctrlmsg.FuncCall subBuilder = new global::Ctrlmsg.FuncCall();
            if (msgCase_ == MsgOneofCase.Call) {
              subBuilder.MergeFrom(Call);
            }
            input.ReadMessage(subBuilder);
            Call = subBuilder;
            break;
          }
          case 18: {
            global::Ctrlmsg.FuncResponse subBuilder = new global::Ctrlmsg.FuncResponse();
            if (msgCase_ == MsgOneofCase.Response) {
              subBuilder.MergeFrom(Response);
            }
            input.ReadMessage(subBuilder);
            Response = subBuilder;
            break;
          }
          case 26: {
            global::Ctrlmsg.Event subBuilder = new global::Ctrlmsg.Event();
            if (msgCase_ == MsgOneofCase.Event) {
              subBuilder.MergeFrom(Event);
            }
            input.ReadMessage(subBuilder);
            Event = subBuilder;
            break;
          }
        }
      }
    }
    #endif

  }

  public sealed partial class FuncResponse : pb::IMessage<FuncResponse>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<FuncResponse> _parser = new pb::MessageParser<FuncResponse>(() => new FuncResponse());
    private pb::UnknownFieldSet _unknownFields;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pb::MessageParser<FuncResponse> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Ctrlmsg.ControllerReflection.Descriptor.MessageTypes[3]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public FuncResponse() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public FuncResponse(FuncResponse other) : this() {
      switch (other.MessageCase) {
        case MessageOneofCase.MonServiceRes:
          MonServiceRes = other.MonServiceRes.Clone();
          break;
        case MessageOneofCase.AuthServiceRes:
          AuthServiceRes = other.AuthServiceRes.Clone();
          break;
        case MessageOneofCase.UserServiceRes:
          UserServiceRes = other.UserServiceRes.Clone();
          break;
        case MessageOneofCase.InvServiceRes:
          InvServiceRes = other.InvServiceRes.Clone();
          break;
        case MessageOneofCase.InteractServiceRes:
          InteractServiceRes = other.InteractServiceRes.Clone();
          break;
        case MessageOneofCase.QuestServiceRes:
          QuestServiceRes = other.QuestServiceRes.Clone();
          break;
      }

      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public FuncResponse Clone() {
      return new FuncResponse(this);
    }

    /// <summary>Field number for the "mon_service_res" field.</summary>
    public const int MonServiceResFieldNumber = 1;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Monster.MonServiceResponse MonServiceRes {
      get { return messageCase_ == MessageOneofCase.MonServiceRes ? (global::Monster.MonServiceResponse) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.MonServiceRes;
      }
    }

    /// <summary>Field number for the "auth_service_res" field.</summary>
    public const int AuthServiceResFieldNumber = 2;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Auth.AuthServiceResponse AuthServiceRes {
      get { return messageCase_ == MessageOneofCase.AuthServiceRes ? (global::Auth.AuthServiceResponse) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.AuthServiceRes;
      }
    }

    /// <summary>Field number for the "user_service_res" field.</summary>
    public const int UserServiceResFieldNumber = 3;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::User.UserServiceResponse UserServiceRes {
      get { return messageCase_ == MessageOneofCase.UserServiceRes ? (global::User.UserServiceResponse) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.UserServiceRes;
      }
    }

    /// <summary>Field number for the "inv_service_res" field.</summary>
    public const int InvServiceResFieldNumber = 4;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Item.InventoryServiceResponse InvServiceRes {
      get { return messageCase_ == MessageOneofCase.InvServiceRes ? (global::Item.InventoryServiceResponse) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.InvServiceRes;
      }
    }

    /// <summary>Field number for the "interact_service_res" field.</summary>
    public const int InteractServiceResFieldNumber = 5;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Interaction.InteractionServiceResponse InteractServiceRes {
      get { return messageCase_ == MessageOneofCase.InteractServiceRes ? (global::Interaction.InteractionServiceResponse) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.InteractServiceRes;
      }
    }

    /// <summary>Field number for the "quest_service_res" field.</summary>
    public const int QuestServiceResFieldNumber = 6;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public global::Quest.QuestServiceResponse QuestServiceRes {
      get { return messageCase_ == MessageOneofCase.QuestServiceRes ? (global::Quest.QuestServiceResponse) message_ : null; }
      set {
        message_ = value;
        messageCase_ = value == null ? MessageOneofCase.None : MessageOneofCase.QuestServiceRes;
      }
    }

    private object message_;
    /// <summary>Enum of possible cases for the "message" oneof.</summary>
    public enum MessageOneofCase {
      None = 0,
      MonServiceRes = 1,
      AuthServiceRes = 2,
      UserServiceRes = 3,
      InvServiceRes = 4,
      InteractServiceRes = 5,
      QuestServiceRes = 6,
    }
    private MessageOneofCase messageCase_ = MessageOneofCase.None;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public MessageOneofCase MessageCase {
      get { return messageCase_; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void ClearMessage() {
      messageCase_ = MessageOneofCase.None;
      message_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override bool Equals(object other) {
      return Equals(other as FuncResponse);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public bool Equals(FuncResponse other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (!object.Equals(MonServiceRes, other.MonServiceRes)) return false;
      if (!object.Equals(AuthServiceRes, other.AuthServiceRes)) return false;
      if (!object.Equals(UserServiceRes, other.UserServiceRes)) return false;
      if (!object.Equals(InvServiceRes, other.InvServiceRes)) return false;
      if (!object.Equals(InteractServiceRes, other.InteractServiceRes)) return false;
      if (!object.Equals(QuestServiceRes, other.QuestServiceRes)) return false;
      if (MessageCase != other.MessageCase) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override int GetHashCode() {
      int hash = 1;
      if (messageCase_ == MessageOneofCase.MonServiceRes) hash ^= MonServiceRes.GetHashCode();
      if (messageCase_ == MessageOneofCase.AuthServiceRes) hash ^= AuthServiceRes.GetHashCode();
      if (messageCase_ == MessageOneofCase.UserServiceRes) hash ^= UserServiceRes.GetHashCode();
      if (messageCase_ == MessageOneofCase.InvServiceRes) hash ^= InvServiceRes.GetHashCode();
      if (messageCase_ == MessageOneofCase.InteractServiceRes) hash ^= InteractServiceRes.GetHashCode();
      if (messageCase_ == MessageOneofCase.QuestServiceRes) hash ^= QuestServiceRes.GetHashCode();
      hash ^= (int) messageCase_;
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (messageCase_ == MessageOneofCase.MonServiceRes) {
        output.WriteRawTag(10);
        output.WriteMessage(MonServiceRes);
      }
      if (messageCase_ == MessageOneofCase.AuthServiceRes) {
        output.WriteRawTag(18);
        output.WriteMessage(AuthServiceRes);
      }
      if (messageCase_ == MessageOneofCase.UserServiceRes) {
        output.WriteRawTag(26);
        output.WriteMessage(UserServiceRes);
      }
      if (messageCase_ == MessageOneofCase.InvServiceRes) {
        output.WriteRawTag(34);
        output.WriteMessage(InvServiceRes);
      }
      if (messageCase_ == MessageOneofCase.InteractServiceRes) {
        output.WriteRawTag(42);
        output.WriteMessage(InteractServiceRes);
      }
      if (messageCase_ == MessageOneofCase.QuestServiceRes) {
        output.WriteRawTag(50);
        output.WriteMessage(QuestServiceRes);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (messageCase_ == MessageOneofCase.MonServiceRes) {
        output.WriteRawTag(10);
        output.WriteMessage(MonServiceRes);
      }
      if (messageCase_ == MessageOneofCase.AuthServiceRes) {
        output.WriteRawTag(18);
        output.WriteMessage(AuthServiceRes);
      }
      if (messageCase_ == MessageOneofCase.UserServiceRes) {
        output.WriteRawTag(26);
        output.WriteMessage(UserServiceRes);
      }
      if (messageCase_ == MessageOneofCase.InvServiceRes) {
        output.WriteRawTag(34);
        output.WriteMessage(InvServiceRes);
      }
      if (messageCase_ == MessageOneofCase.InteractServiceRes) {
        output.WriteRawTag(42);
        output.WriteMessage(InteractServiceRes);
      }
      if (messageCase_ == MessageOneofCase.QuestServiceRes) {
        output.WriteRawTag(50);
        output.WriteMessage(QuestServiceRes);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public int CalculateSize() {
      int size = 0;
      if (messageCase_ == MessageOneofCase.MonServiceRes) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(MonServiceRes);
      }
      if (messageCase_ == MessageOneofCase.AuthServiceRes) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(AuthServiceRes);
      }
      if (messageCase_ == MessageOneofCase.UserServiceRes) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(UserServiceRes);
      }
      if (messageCase_ == MessageOneofCase.InvServiceRes) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(InvServiceRes);
      }
      if (messageCase_ == MessageOneofCase.InteractServiceRes) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(InteractServiceRes);
      }
      if (messageCase_ == MessageOneofCase.QuestServiceRes) {
        size += 1 + pb::CodedOutputStream.ComputeMessageSize(QuestServiceRes);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(FuncResponse other) {
      if (other == null) {
        return;
      }
      switch (other.MessageCase) {
        case MessageOneofCase.MonServiceRes:
          if (MonServiceRes == null) {
            MonServiceRes = new global::Monster.MonServiceResponse();
          }
          MonServiceRes.MergeFrom(other.MonServiceRes);
          break;
        case MessageOneofCase.AuthServiceRes:
          if (AuthServiceRes == null) {
            AuthServiceRes = new global::Auth.AuthServiceResponse();
          }
          AuthServiceRes.MergeFrom(other.AuthServiceRes);
          break;
        case MessageOneofCase.UserServiceRes:
          if (UserServiceRes == null) {
            UserServiceRes = new global::User.UserServiceResponse();
          }
          UserServiceRes.MergeFrom(other.UserServiceRes);
          break;
        case MessageOneofCase.InvServiceRes:
          if (InvServiceRes == null) {
            InvServiceRes = new global::Item.InventoryServiceResponse();
          }
          InvServiceRes.MergeFrom(other.InvServiceRes);
          break;
        case MessageOneofCase.InteractServiceRes:
          if (InteractServiceRes == null) {
            InteractServiceRes = new global::Interaction.InteractionServiceResponse();
          }
          InteractServiceRes.MergeFrom(other.InteractServiceRes);
          break;
        case MessageOneofCase.QuestServiceRes:
          if (QuestServiceRes == null) {
            QuestServiceRes = new global::Quest.QuestServiceResponse();
          }
          QuestServiceRes.MergeFrom(other.QuestServiceRes);
          break;
      }

      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 10: {
            global::Monster.MonServiceResponse subBuilder = new global::Monster.MonServiceResponse();
            if (messageCase_ == MessageOneofCase.MonServiceRes) {
              subBuilder.MergeFrom(MonServiceRes);
            }
            input.ReadMessage(subBuilder);
            MonServiceRes = subBuilder;
            break;
          }
          case 18: {
            global::Auth.AuthServiceResponse subBuilder = new global::Auth.AuthServiceResponse();
            if (messageCase_ == MessageOneofCase.AuthServiceRes) {
              subBuilder.MergeFrom(AuthServiceRes);
            }
            input.ReadMessage(subBuilder);
            AuthServiceRes = subBuilder;
            break;
          }
          case 26: {
            global::User.UserServiceResponse subBuilder = new global::User.UserServiceResponse();
            if (messageCase_ == MessageOneofCase.UserServiceRes) {
              subBuilder.MergeFrom(UserServiceRes);
            }
            input.ReadMessage(subBuilder);
            UserServiceRes = subBuilder;
            break;
          }
          case 34: {
            global::Item.InventoryServiceResponse subBuilder = new global::Item.InventoryServiceResponse();
            if (messageCase_ == MessageOneofCase.InvServiceRes) {
              subBuilder.MergeFrom(InvServiceRes);
            }
            input.ReadMessage(subBuilder);
            InvServiceRes = subBuilder;
            break;
          }
          case 42: {
            global::Interaction.InteractionServiceResponse subBuilder = new global::Interaction.InteractionServiceResponse();
            if (messageCase_ == MessageOneofCase.InteractServiceRes) {
              subBuilder.MergeFrom(InteractServiceRes);
            }
            input.ReadMessage(subBuilder);
            InteractServiceRes = subBuilder;
            break;
          }
          case 50: {
            global::Quest.QuestServiceResponse subBuilder = new global::Quest.QuestServiceResponse();
            if (messageCase_ == MessageOneofCase.QuestServiceRes) {
              subBuilder.MergeFrom(QuestServiceRes);
            }
            input.ReadMessage(subBuilder);
            QuestServiceRes = subBuilder;
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 10: {
            global::Monster.MonServiceResponse subBuilder = new global::Monster.MonServiceResponse();
            if (messageCase_ == MessageOneofCase.MonServiceRes) {
              subBuilder.MergeFrom(MonServiceRes);
            }
            input.ReadMessage(subBuilder);
            MonServiceRes = subBuilder;
            break;
          }
          case 18: {
            global::Auth.AuthServiceResponse subBuilder = new global::Auth.AuthServiceResponse();
            if (messageCase_ == MessageOneofCase.AuthServiceRes) {
              subBuilder.MergeFrom(AuthServiceRes);
            }
            input.ReadMessage(subBuilder);
            AuthServiceRes = subBuilder;
            break;
          }
          case 26: {
            global::User.UserServiceResponse subBuilder = new global::User.UserServiceResponse();
            if (messageCase_ == MessageOneofCase.UserServiceRes) {
              subBuilder.MergeFrom(UserServiceRes);
            }
            input.ReadMessage(subBuilder);
            UserServiceRes = subBuilder;
            break;
          }
          case 34: {
            global::Item.InventoryServiceResponse subBuilder = new global::Item.InventoryServiceResponse();
            if (messageCase_ == MessageOneofCase.InvServiceRes) {
              subBuilder.MergeFrom(InvServiceRes);
            }
            input.ReadMessage(subBuilder);
            InvServiceRes = subBuilder;
            break;
          }
          case 42: {
            global::Interaction.InteractionServiceResponse subBuilder = new global::Interaction.InteractionServiceResponse();
            if (messageCase_ == MessageOneofCase.InteractServiceRes) {
              subBuilder.MergeFrom(InteractServiceRes);
            }
            input.ReadMessage(subBuilder);
            InteractServiceRes = subBuilder;
            break;
          }
          case 50: {
            global::Quest.QuestServiceResponse subBuilder = new global::Quest.QuestServiceResponse();
            if (messageCase_ == MessageOneofCase.QuestServiceRes) {
              subBuilder.MergeFrom(QuestServiceRes);
            }
            input.ReadMessage(subBuilder);
            QuestServiceRes = subBuilder;
            break;
          }
        }
      }
    }
    #endif

  }

  #endregion

}

#endregion Designer generated code
